Index: /branches/PushGP/HeuristicLab.PushGP/FeatureTests/Program.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/FeatureTests/Program.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/FeatureTests/Program.cs	(revision 15334)
@@ -12,4 +12,5 @@
   using HeuristicLab.Problems.ProgramSynthesis.Push.Data.Pool;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Extensions;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Generators.CodeGenerator;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
@@ -23,11 +24,12 @@
     private const int ExampleCount = 200;
     private const int InstanceCount = 1024;
-    private const int PopulationCount = 100;
+    private const int PopulationCount = 1000;
 
     private static int TotalInstanceCount => PopulationCount * InstanceCount * ExampleCount;
 
     static void Main(string[] args) {
+      // object pooling
       //Test1();
-      //Test1_2();
+      Test1_2();
       //Test3();
 
@@ -53,8 +55,37 @@
       //TestSplitLogic();
       //TestStringBuilder();
-      TestRandomReset();
+      //TestRandomReset();
+
+      //TestRandomBiased(0, 4, 0.01);
+      //TestRandomBiased(0, 4, 0.25);
+      //TestRandomBiased(0, 4, 0.5);
+      //TestRandomBiased(0, 4, 1);
+      //TestRandomBiased(0, 4, 2);
+      //TestRandomBiased(0, 4, 3);
+      //TestRandomBiased(0, 4, 4);
+
 
       Console.WriteLine("\nPress any key to continue...");
       Console.ReadKey(false);
+    }
+
+    private static void TestRandomBiased(int min, int max, double bias) {
+      var random = new MersenneTwister();
+      var total = 100000;
+
+      var distribution = Enumerable
+        .Range(0, total)
+        .Select(_ => random.NextBiased(min, max, bias))
+        .GroupBy(x => x)
+        .OrderBy(g => g.Key)
+        .ToDictionary(g => g.Key, g => g.Count() / (double)total * 100);
+
+      Console.WriteLine($@"{min}|{max}|{bias}");
+
+      foreach (var entry in distribution) {
+        Console.WriteLine($@"{entry.Key}: {entry.Value}");
+      }
+
+      Console.WriteLine();
     }
 
@@ -496,5 +527,5 @@
       var config = new PushConfiguration {
         EvalPushLimit = 1024,
-        MaxPointsInProgram = 1024
+        MaxProgramLength = 1024
       };
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/BenchmarkSuiteDataDescriptor.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/BenchmarkSuiteDataDescriptor.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/BenchmarkSuiteDataDescriptor.cs	(revision 15334)
@@ -11,6 +11,6 @@
     private const string InstanceArchiveName = "HeuristicLab.BenchmarkSuite.Data.BenchmarkExamples.zip";
     private const string ResourcePath = @".*\.Data\.";
-    private const string ExampleFieldDelimiter = ",";
-
+    private const char ExampleFieldDelimiter = ',';
+    private const char ExampleFieldQualifier = '"';
     private Example[] examples;
 
@@ -36,5 +36,5 @@
 
         using (var reader = new StreamReader(entry.Open())) {
-          var lines = CsvParser.Parse(reader, ',', '"');
+          var lines = CsvParser.Parse(reader, ExampleFieldDelimiter, ExampleFieldQualifier);
 
           foreach (var line in lines) {
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/BenchmarkSuiteOverview.cd
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/BenchmarkSuiteOverview.cd	(revision 15334)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/BenchmarkSuiteOverview.cd	(revision 15334)
@@ -0,0 +1,106 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<ClassDiagram MajorVersion="1" MinorVersion="1" MembersFormat="NameAndType">
+  <Class Name="HeuristicLab.BenchmarkSuite.BenchmarkSuiteInstanceProvider">
+    <Position X="4.25" Y="3.25" Width="3.75" />
+    <Members>
+      <Property Name="Description" Hidden="true" />
+      <Method Name="LoadData" Hidden="true" />
+      <Field Name="name" Hidden="true" />
+      <Property Name="Name" Hidden="true" />
+      <Field Name="referencePublication" Hidden="true" />
+      <Property Name="ReferencePublication" Hidden="true" />
+      <Field Name="webLink" Hidden="true" />
+      <Property Name="WebLink" Hidden="true" />
+    </Members>
+    <TypeIdentifier>
+      <HashCode>QAAAAAAAAIAwAAAAAAAAAAQAAIAEAAAAAAAAQAAAAEA=</HashCode>
+      <FileName>BenchmarkSuiteInstanceProvider.cs</FileName>
+    </TypeIdentifier>
+  </Class>
+  <Class Name="HeuristicLab.BenchmarkSuite.BenchmarkSuiteDataDescriptor">
+    <Position X="3.25" Y="0.75" Width="2.5" />
+    <Members>
+      <Method Name="CloneExamples" Hidden="true" />
+      <Property Name="Description" Hidden="true" />
+      <Field Name="ExampleFieldDelimiter" Hidden="true" />
+      <Field Name="ExampleFieldQualifier" Hidden="true" />
+      <Field Name="examples" Hidden="true" />
+      <Property Name="FileName" Hidden="true" />
+      <Method Name="GetResourceName" Hidden="true" />
+      <Property Name="InputArgumentCount" Hidden="true" />
+      <Field Name="InstanceArchiveName" Hidden="true" />
+      <Property Name="Name" Hidden="true" />
+      <Property Name="OutputArgumentCount" Hidden="true" />
+      <Method Name="ParseData" Hidden="true" />
+      <Field Name="ResourcePath" Hidden="true" />
+    </Members>
+    <Compartments>
+      <Compartment Name="Fields" Collapsed="true" />
+      <Compartment Name="Properties" Collapsed="true" />
+    </Compartments>
+    <TypeIdentifier>
+      <HashCode>AAEAAADAgAAgAAFAQAAgAAQAAAAQAABAAAAAAABEAAA=</HashCode>
+      <FileName>BenchmarkSuiteDataDescriptor.cs</FileName>
+    </TypeIdentifier>
+    <Lollipop Position="0.2" />
+  </Class>
+  <Class Name="HeuristicLab.BenchmarkSuite.Example">
+    <Position X="0.75" Y="2.75" Width="2.5" />
+    <Members>
+      <Method Name="Clone" Hidden="true" />
+      <Field Name="emptyBooleans" Hidden="true" />
+      <Field Name="emptyBooleanVectors" Hidden="true" />
+      <Field Name="emptyChars" Hidden="true" />
+      <Field Name="emptyFloats" Hidden="true" />
+      <Field Name="emptyFloatVectors" Hidden="true" />
+      <Field Name="emptyIntegers" Hidden="true" />
+      <Field Name="emptyIntegerVectors" Hidden="true" />
+      <Field Name="emptyStrings" Hidden="true" />
+      <Field Name="emptyStringVectors" Hidden="true" />
+      <Method Name="Example" Hidden="true" />
+      <Field Name="NewLineSeparator" Hidden="true" />
+      <Field Name="outputPrint" Hidden="true" />
+    </Members>
+    <TypeIdentifier>
+      <HashCode>KAgkhQAACAAEEUgAICAIAIFAQAIkEBwIAAEAAQCAAVA=</HashCode>
+      <FileName>Example.cs</FileName>
+    </TypeIdentifier>
+  </Class>
+  <Class Name="HeuristicLab.BenchmarkSuite.ProblemData">
+    <Position X="4.5" Y="4.75" Width="3.5" />
+    <Members>
+      <Method Name="Clone" Hidden="true" />
+      <Method Name="ProblemData" Hidden="true" />
+      <Field Name="ProblemType" Hidden="true" />
+    </Members>
+    <TypeIdentifier>
+      <HashCode>IAICASAAAAAIAAIAAEAAAAEAAAAQAABIAgAAQBAAABA=</HashCode>
+      <FileName>ProblemData.cs</FileName>
+    </TypeIdentifier>
+    <ShowAsAssociation>
+      <Property Name="Examples" />
+    </ShowAsAssociation>
+  </Class>
+  <Class Name="HeuristicLab.BenchmarkSuite.Problems.Median" Collapsed="true">
+    <Position X="0.75" Y="0.5" Width="2" />
+    <TypeIdentifier>
+      <HashCode>AAAAAAAAgAAgAABAIAAAAAQAAAAUAAAAAEAAAABEAAA=</HashCode>
+      <FileName>Problems\Median.cs</FileName>
+    </TypeIdentifier>
+  </Class>
+  <Class Name="HeuristicLab.BenchmarkSuite.Problems.NumberIO" Collapsed="true">
+    <Position X="0.75" Y="1.5" Width="2" />
+    <TypeIdentifier>
+      <HashCode>AAAAAAAAgAAgAABAIAAAAAQAAAAUAAAAAEAAAABEAAA=</HashCode>
+      <FileName>Problems\NumberIo.cs</FileName>
+    </TypeIdentifier>
+  </Class>
+  <Enum Name="HeuristicLab.BenchmarkSuite.ExampleArgumentType">
+    <Position X="6" Y="0.5" Width="2" />
+    <TypeIdentifier>
+      <HashCode>AAAAABAAAQAAAAAAQAAAAAAAAAQAAiEAAAAAAAAkAAA=</HashCode>
+      <FileName>ExampleArgumentType.cs</FileName>
+    </TypeIdentifier>
+  </Enum>
+  <Font Name="Segoe UI" Size="9" />
+</ClassDiagram>
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/HeuristicLab.BenchmarkSuite.csproj
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/HeuristicLab.BenchmarkSuite.csproj	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/HeuristicLab.BenchmarkSuite.csproj	(revision 15334)
@@ -164,4 +164,7 @@
     </ProjectReference>
   </ItemGroup>
+  <ItemGroup>
+    <None Include="BenchmarkSuiteOverview.cd" />
+  </ItemGroup>
   <Choose>
     <When Condition="'$(VisualStudioVersion)' == '10.0' And '$(IsCodedUITest)' == 'True'">
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ProblemData.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ProblemData.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ProblemData.cs	(revision 15334)
@@ -25,6 +25,7 @@
       BestResult = origin.BestResult;
       WorstResult = origin.WorstResult;
-      InputArgumentTypes = origin.InputArgumentTypes;
-      OutputArgumentTypes = origin.OutputArgumentTypes;
+
+      InputArgumentTypes = (ExampleArgumentType[])origin.InputArgumentTypes.Clone();
+      OutputArgumentTypes = (ExampleArgumentType[])origin.OutputArgumentTypes.Clone();
 
       if (origin.Examples != null)
@@ -35,4 +36,5 @@
       FloatStringFormat = origin.FloatStringFormat;
       ProblemType = origin.ProblemType;
+      ProgramExecutionBudget = origin.ProgramExecutionBudget;
     }
 
@@ -82,4 +84,10 @@
     public ErcOptions ErcOptions { get; set; }
 
+    /// <summary>
+    /// Represents the maximum number of programs that will be executed before a run is terminated, which is the product of the maximum generations, the population size, and the size of the training set.
+    /// </summary>
+    [Storable]
+    public int ProgramExecutionBudget { get; set; }
+
     [Storable]
     public string FloatStringFormat { get; set; }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Checksum.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Checksum.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Checksum.cs	(revision 15334)
@@ -19,7 +19,8 @@
         Name = Name,
         Description = Description,
+        ProgramExecutionBudget = 30000000,
         Examples = CloneExamples(),
         BestResult = 0,
-        WorstResult = char.MaxValue,
+        WorstResult = 1000,
         InputArgumentTypes = new[] { ExampleArgumentType.String },
         OutputArgumentTypes = new[] { ExampleArgumentType.Print },
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/CollatzNumbers.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/CollatzNumbers.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/CollatzNumbers.cs	(revision 15334)
@@ -17,7 +17,8 @@
         Name = Name,
         Description = Description,
+        ProgramExecutionBudget = 60000000,
         Examples = CloneExamples(),
         BestResult = 0,
-        WorstResult = 300,
+        WorstResult = 1000000,
         InputArgumentTypes = new[] { ExampleArgumentType.Integer },
         OutputArgumentTypes = new[] { ExampleArgumentType.Integer },
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/CompareStringLengths.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/CompareStringLengths.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/CompareStringLengths.cs	(revision 15334)
@@ -17,4 +17,5 @@
         Name = Name,
         Description = Description,
+        ProgramExecutionBudget = 30000000,
         Examples = CloneExamples(),
         BestResult = 0,
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/CountOdds.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/CountOdds.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/CountOdds.cs	(revision 15334)
@@ -17,7 +17,8 @@
         Name = Name,
         Description = Description,
+        ProgramExecutionBudget = 60000000,
         Examples = CloneExamples(),
         BestResult = 0,
-        WorstResult = 50,
+        WorstResult = 1000,
         InputArgumentTypes = new[] { ExampleArgumentType.IntegerVector },
         OutputArgumentTypes = new[] { ExampleArgumentType.Integer },
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Digits.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Digits.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Digits.cs	(revision 15334)
@@ -18,7 +18,8 @@
         Name = Name,
         Description = Description,
+        ProgramExecutionBudget = 30000000,
         Examples = CloneExamples(),
         BestResult = 0,
-        WorstResult = 20,
+        WorstResult = 5000,
         InputArgumentTypes = new[] { ExampleArgumentType.Integer },
         OutputArgumentTypes = new[] { ExampleArgumentType.Print },
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/DoubleLetters.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/DoubleLetters.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/DoubleLetters.cs	(revision 15334)
@@ -18,7 +18,8 @@
         Name = Name,
         Description = Description,
+        ProgramExecutionBudget = 30000000,
         Examples = CloneExamples(),
         BestResult = 0,
-        WorstResult = 100,
+        WorstResult = 5000,
         InputArgumentTypes = new[] { ExampleArgumentType.String },
         OutputArgumentTypes = new[] { ExampleArgumentType.Print },
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/EvenSquares.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/EvenSquares.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/EvenSquares.cs	(revision 15334)
@@ -1,3 +1,5 @@
 ﻿namespace HeuristicLab.BenchmarkSuite.Problems {
+  using System.Linq;
+
   public class EvenSquares : BenchmarkSuiteDataDescriptor {
     private const string name = "Even Sqaures - Hard";
@@ -15,7 +17,8 @@
         Name = Name,
         Description = Description,
+        ProgramExecutionBudget = 30000000,
         Examples = CloneExamples(),
         BestResult = 0,
-        WorstResult = 400,
+        WorstResult = 5000,
         InputArgumentTypes = new[] { ExampleArgumentType.Integer },
         OutputArgumentTypes = new[] { ExampleArgumentType.Print },
@@ -34,4 +37,7 @@
         InputInteger = ExampleArgumentConverter.ConvertIntegers(input),
         OutputPrint = output[0],
+
+        // helper
+        OutputIntegerVector = new [] { output[0].Split('\n').Select(ExampleArgumentConverter.ConvertInteger).ToArray() }
       };
     }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/ForLoopIndex.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/ForLoopIndex.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/ForLoopIndex.cs	(revision 15334)
@@ -19,7 +19,8 @@
         Name = Name,
         Description = Description,
+        ProgramExecutionBudget = 30000000,
         Examples = CloneExamples(),
         BestResult = 0,
-        WorstResult = 1000,
+        WorstResult = 5000,
         InputArgumentTypes = new[] { ExampleArgumentType.Integer, ExampleArgumentType.Integer, ExampleArgumentType.Integer },
         OutputArgumentTypes = new[] { ExampleArgumentType.Print },
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Grades.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Grades.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Grades.cs	(revision 15334)
@@ -1,3 +1,5 @@
 ﻿namespace HeuristicLab.BenchmarkSuite.Problems {
+  using System;
+
   using HeuristicLab.Problems.ProgramSynthesis.Base.Erc.Integer;
   using HeuristicLab.Problems.ProgramSynthesis.Base.Erc.String;
@@ -6,5 +8,5 @@
     private const string name = "Grades - Hard";
     private const string fileName = "Grades.csv";
-    private const string description = "Given 5 integers, the first four represent the lower numeric thresholds for achieving an A, B, C, and D, and will be distinct and in descending order.The fifth represents the student’s numeric grade.The program must print Student has a X grade., where X is A, B, C, D, or F depending on the thresholds and the numeric grade.";
+    private const string description = "Given 5 integers, the first four represent the lower numeric thresholds for achieving an A, B, C, and D, and will be distinct and in descending order. The fifth represents the student’s numeric grade. The program must print Student has a X grade., where X is A, B, C, D, or F depending on the thresholds and the numeric grade.";
 
     protected override string FileName { get { return fileName; } }
@@ -18,7 +20,8 @@
         Name = Name,
         Description = Description,
+        ProgramExecutionBudget = 60000000,
         Examples = CloneExamples(),
         BestResult = 0,
-        WorstResult = 25,
+        WorstResult = 5000,
         InputArgumentTypes = new[] { ExampleArgumentType.Integer, ExampleArgumentType.Integer, ExampleArgumentType.Integer, ExampleArgumentType.Integer, ExampleArgumentType.Integer },
         OutputArgumentTypes = new[] { ExampleArgumentType.Print },
@@ -39,4 +42,8 @@
 
     protected override Example ParseExample(string[] input, string[] output) {
+      char grade;
+      if (!GetGrade(output[0], out grade))
+        throw new InvalidOperationException("Unable to parse grade.");
+
       return new Example {
         InputArgs = input,
@@ -44,5 +51,20 @@
         InputInteger = ExampleArgumentConverter.ConvertIntegers(input),
         OutputPrint = output[0],
+
+        // help
+        OutputChar = new[] { grade }
       };
+    }
+
+    public static bool GetGrade(string str, out char grade) {
+      const string start = "Student has a ";
+
+      if (str.StartsWith(start) && str.Length > start.Length) {
+        grade = str[start.Length];
+        return true;
+      }
+
+      grade = default(char);
+      return false;
     }
   }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/LastIndexOfZero.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/LastIndexOfZero.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/LastIndexOfZero.cs	(revision 15334)
@@ -17,7 +17,8 @@
         Name = Name,
         Description = Description,
+        ProgramExecutionBudget = 45000000,
         Examples = CloneExamples(),
         BestResult = 0,
-        WorstResult = 50,
+        WorstResult = 1000000,
         InputArgumentTypes = new[] { ExampleArgumentType.IntegerVector },
         OutputArgumentTypes = new[] { ExampleArgumentType.Integer },
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Median.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Median.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Median.cs	(revision 15334)
@@ -17,7 +17,8 @@
         Name = Name,
         Description = Description,
+        ProgramExecutionBudget = 20000000,
         Examples = CloneExamples(),
         BestResult = 0,
-        WorstResult = 100,
+        WorstResult = 1,
         InputArgumentTypes = new[] { ExampleArgumentType.Integer, ExampleArgumentType.Integer, ExampleArgumentType.Integer },
         OutputArgumentTypes = new[] { ExampleArgumentType.Print },
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/MirrorImage.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/MirrorImage.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/MirrorImage.cs	(revision 15334)
@@ -17,4 +17,5 @@
         Name = Name,
         Description = Description,
+        ProgramExecutionBudget = 30000000,
         Examples = CloneExamples(),
         BestResult = 0,
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/NegativeToZero.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/NegativeToZero.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/NegativeToZero.cs	(revision 15334)
@@ -18,7 +18,8 @@
         Name = Name,
         Description = Description,
+        ProgramExecutionBudget = 60000000,
         Examples = CloneExamples(),
         BestResult = 0,
-        WorstResult = 50000,
+        WorstResult = 5000,
         InputArgumentTypes = new[] { ExampleArgumentType.IntegerVector },
         OutputArgumentTypes = new[] { ExampleArgumentType.IntegerVector },
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/NumberIo.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/NumberIo.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/NumberIo.cs	(revision 15334)
@@ -20,7 +20,8 @@
         Name = Name,
         Description = Description,
+        ProgramExecutionBudget = 5000000,
         Examples = CloneExamples(),
         BestResult = 0,
-        WorstResult = 400,
+        WorstResult = 5000,
         InputArgumentTypes = new[] { ExampleArgumentType.Float, ExampleArgumentType.Integer },
         OutputArgumentTypes = new[] { ExampleArgumentType.Print },
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/PigLatin.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/PigLatin.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/PigLatin.cs	(revision 15334)
@@ -19,7 +19,8 @@
         Name = Name,
         Description = Description,
+        ProgramExecutionBudget = 60000000,
         Examples = CloneExamples(),
         BestResult = 0,
-        WorstResult = 100,
+        WorstResult = 5000,
         InputArgumentTypes = new[] { ExampleArgumentType.String },
         OutputArgumentTypes = new[] { ExampleArgumentType.Print },
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/ReplaceSpaceWithNewline.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/ReplaceSpaceWithNewline.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/ReplaceSpaceWithNewline.cs	(revision 15334)
@@ -19,7 +19,8 @@
         Name = Name,
         Description = Description,
+        ProgramExecutionBudget = 30000000,
         Examples = CloneExamples(),
         BestResult = 0,
-        WorstResult = 20,
+        WorstResult = 5000,
         InputArgumentTypes = new[] { ExampleArgumentType.String },
         OutputArgumentTypes = new[] { ExampleArgumentType.Print, ExampleArgumentType.Integer },
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/ScrabbleScore.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/ScrabbleScore.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/ScrabbleScore.cs	(revision 15334)
@@ -48,7 +48,8 @@
         Name = Name,
         Description = Description,
+        ProgramExecutionBudget = 60000000,
         Examples = CloneExamples(),
         BestResult = 0,
-        WorstResult = 500,
+        WorstResult = 1000,
         InputArgumentTypes = new[] { ExampleArgumentType.String },
         OutputArgumentTypes = new[] { ExampleArgumentType.Integer },
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/SmallOrLarge.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/SmallOrLarge.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/SmallOrLarge.cs	(revision 15334)
@@ -19,7 +19,8 @@
         Name = Name,
         Description = Description,
+        ProgramExecutionBudget = 30000000,
         Examples = CloneExamples(),
         BestResult = 0,
-        WorstResult = 5,
+        WorstResult = 5000,
         InputArgumentTypes = new[] { ExampleArgumentType.Integer },
         OutputArgumentTypes = new[] { ExampleArgumentType.Print },
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Smallest.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Smallest.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Smallest.cs	(revision 15334)
@@ -17,12 +17,13 @@
         Name = Name,
         Description = Description,
+        ProgramExecutionBudget = 20000000,
         Examples = CloneExamples(),
         BestResult = 0,
-        WorstResult = 100,
+        WorstResult = 1,
         InputArgumentTypes = new[] { ExampleArgumentType.Integer, ExampleArgumentType.Integer, ExampleArgumentType.Integer, ExampleArgumentType.Integer },
-        OutputArgumentTypes = new[] { ExampleArgumentType.Integer },
+        OutputArgumentTypes = new[] { ExampleArgumentType.Print },
         TrainingCount = 100,
         TestCount = 1000,
-        EnabledDataTypes = DataTypes.Exec | DataTypes.Integer | DataTypes.Boolean,
+        EnabledDataTypes = DataTypes.Exec | DataTypes.Integer | DataTypes.Boolean | DataTypes.Print,
         MaxSize = 200,
         EvalLimit = 200,
@@ -40,4 +41,6 @@
         OutputArgs = output,
         InputInteger = ExampleArgumentConverter.ConvertIntegers(input),
+        OutputPrint = output[0],
+        // Helper
         OutputInteger = ExampleArgumentConverter.ConvertIntegers(output[0]),
       };
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/StringDifferences.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/StringDifferences.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/StringDifferences.cs	(revision 15334)
@@ -6,5 +6,5 @@
     private const string name = "String Differences - Hard";
     private const string fileName = "StringDifferences.csv";
-    private const string description = "Given 2 strings (without whitespace) as input, find the indices at which the strings have different characters, stopping at the end of the shorter one.For each such index, print a line containing the index as well as the character in each string. For example, if the strings are “dealer” and “dollars”, the program should print: 1 e o, 2 a l, 4 e a";
+    private const string description = "Given 2 strings (without whitespace) as input, find the indices at which the strings have different characters, stopping at the end of the shorter one. For each such index, print a line containing the index as well as the character in each string. For example, if the strings are “dealer” and “dollars”, the program should print: 1 e o, 2 a l, 4 e a";
 
     protected override string FileName { get { return fileName; } }
@@ -18,7 +18,8 @@
         Name = Name,
         Description = Description,
+        ProgramExecutionBudget = 60000000,
         Examples = CloneExamples(),
         BestResult = 0,
-        WorstResult = 100,
+        WorstResult = 5000,
         InputArgumentTypes = new[] { ExampleArgumentType.String, ExampleArgumentType.String },
         OutputArgumentTypes = new[] { ExampleArgumentType.Print },
